# Iron Man Helmet
# Gage Condon

import time, datetime, geocoder, requests
from adafruit_crickit import crickit
from luma.core.interface.serial import i2c
from luma.core.render import canvas
from luma.oled.device import ssd1306
from time import sleep
from PIL import Image, ImageDraw, ImageFont
from geopy.geocoders import Nominatim

# instantiate a new Nominatim client
app = Nominatim(user_agent="location")

# set up communication with seesaw
ss = crickit.seesaw

# initialize the two motors
motor_1 = crickit.dc_motor_1
motor_2 = crickit.dc_motor_2

# intialize led eyes
eyes = crickit.SIGNAL1
ss.pin_mode(eyes, ss.OUTPUT)

# set oled device to not shut off after displaying something
def do_nothing(obj):
    pass

#initialize heads up display
device = ssd1306(i2c(port=1, address=0x3C), rotate=2)
device.cleanup = do_nothing
device.clear()

# variable to hold status of helemt open/close
helmet_open = False
# function that opens the helmet and keeps it open
# note that both motors will stay on in order to keep the helmet from falling down
def helmet_open():
    motor_1.throttle = 1
    motor_2.throttle = -1
    eyes_off()
    time.sleep(2)
    motor_1.throttle = .6
    motor_2.throttle = -.6
    helmet_open = True
    return helmet_open

# function that closes the helmet and turns off the motors
def helmet_close():
    motor_1.throttle = -.2
    motor_2.throttle = .2
    time.sleep(0.1)
    motor_1.throttle = 0
    motor_2.throttle = 0
    time.sleep(0.3)
    eyes_on()
    helmet_open = False
    return helmet_open

# function to light up eyes
def eyes_on():
    ss.digital_write(eyes, True)

#function to turn off eyes
def eyes_off():
    ss.digital_write(eyes, False)

# function for testing a motor if there are any issues
def motor_test(motor):
    motor.throttle = 1
    time.sleep(1)
    motor.throttle = 0

# function that displays the current date, time, and location
def display_dateTimeLocation():
    cdt = datetime.datetime.now()
    min1 = str(cdt.minute)
    if cdt.hour>12:
        hour = cdt.hour-12
    else:
        hour = cdt.hour
    if hour<10:
        hour = "0"+str(hour)
    else:
        hour = str(hour)
    if cdt.minute<10:
        min1 = "0"+str(cdt.minute)

    today = datetime.date.today()
    today = today.strftime("%B %d, %Y")

    city_state_string = get_city_state()

    output = Image.new("1", (128,64))
    add_to_image = ImageDraw.Draw(output)
    add_to_image.text((0, 0), today, fill="white")
    add_to_image.text((0, 10), hour, fill="white")
    add_to_image.text((11,10), ":", fill="white")
    add_to_image.text((15,10), min1, fill="white")
    add_to_image.text((0,20), city_state_string, fill="white")
    device.display(output)

# function that gets address data from coordinates
def get_address_by_location(latitude, longitude, language="en"):
    # build coordinates string to pass to reverse() function
    coordinates = f"{latitude}, {longitude}"
    # sleep for a second to respect Usage Policy
    time.sleep(1)
    try:
        return app.reverse(coordinates, language=language).raw
    except:
        return get_address_by_location(latitude, longitude)

# function that gets city and state string to display
def get_city_state():
    # get lat long
    g = geocoder.ip('me')
    latitude = g.latlng[0]
    longitude = g.latlng[1]
    location_data = get_address_by_location(latitude, longitude)
    city_state_string = location_data["address"]["city"]+", "+location_data["address"]["state"]
    return city_state_string

def test():
    return asdf

eyes_on()



time.sleep(2)


helmet_open()
display_dateTimeLocation()
time.sleep(5)
helmet_close()























